/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_TEST_AUDIO_Controller_STUB_DEFAULT_HPP_
#define V2_TEST_AUDIO_Controller_STUB_DEFAULT_HPP_


#include <CommonAPI/Export.hpp>

#include <v2/Test/Audio/ControllerStub.hpp>
#include <cassert>
#include <sstream>

# if defined(_MSC_VER)
#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif
# endif

namespace v2 {
namespace Test {
namespace Audio {

/**
 * Provides a default implementation for ControllerStubRemoteEvent and
 * ControllerStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class COMMONAPI_EXPORT_CLASS_EXPLICIT ControllerStubDefault
    : public virtual ControllerStub {
public:
    COMMONAPI_EXPORT ControllerStubDefault()
        : remoteEventHandler_(this),
          interfaceVersion_(Controller::getInterfaceVersion()) {
    }

    COMMONAPI_EXPORT const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return interfaceVersion_;
    }

    COMMONAPI_EXPORT ControllerStubRemoteEvent* initStubAdapter(const std::shared_ptr< ControllerStubAdapter> &_adapter) {
        CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_ = _adapter;
        return &remoteEventHandler_;
    }

    COMMONAPI_EXPORT virtual const ::v2::Test::Audio::Controller::KeyValueString &getIVIDeviceInfoAttribute() {
        return iVIDeviceInfoAttributeValue_;
    }
    COMMONAPI_EXPORT virtual const ::v2::Test::Audio::Controller::KeyValueString &getIVIDeviceInfoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return getIVIDeviceInfoAttribute();
    }
    COMMONAPI_EXPORT virtual void setIVIDeviceInfoAttribute(::v2::Test::Audio::Controller::KeyValueString _value) {
        const bool valueChanged = trySetIVIDeviceInfoAttribute(std::move(_value));
        if (valueChanged) {
            fireIVIDeviceInfoAttributeChanged(iVIDeviceInfoAttributeValue_);
        }
    }
    COMMONAPI_EXPORT virtual void setIVIDeviceInfoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, ::v2::Test::Audio::Controller::KeyValueString _value) {
        (void)_client;
        setIVIDeviceInfoAttribute(_value);
    }
    COMMONAPI_EXPORT virtual const std::vector< std::string > &getAudioSourceTypesAttribute() {
        return audioSourceTypesAttributeValue_;
    }
    COMMONAPI_EXPORT virtual const std::vector< std::string > &getAudioSourceTypesAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return getAudioSourceTypesAttribute();
    }
    COMMONAPI_EXPORT virtual void setAudioSourceTypesAttribute(std::vector< std::string > _value) {
        const bool valueChanged = trySetAudioSourceTypesAttribute(std::move(_value));
        if (valueChanged) {
            fireAudioSourceTypesAttributeChanged(audioSourceTypesAttributeValue_);
        }
    }
    COMMONAPI_EXPORT virtual const ::v2::Test::Audio::Controller::VolumeInfo &getVolumeInfoAttribute() {
        return volumeInfoAttributeValue_;
    }
    COMMONAPI_EXPORT virtual const ::v2::Test::Audio::Controller::VolumeInfo &getVolumeInfoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return getVolumeInfoAttribute();
    }
    COMMONAPI_EXPORT virtual void setVolumeInfoAttribute(::v2::Test::Audio::Controller::VolumeInfo _value) {
        const bool valueChanged = trySetVolumeInfoAttribute(std::move(_value));
        if (valueChanged) {
            fireVolumeInfoAttributeChanged(volumeInfoAttributeValue_);
        }
    }
    COMMONAPI_EXPORT virtual const ::v2::Test::Audio::Controller::KeyValueByteBuffer &getKeyValueByteBufferMapAttribute() {
        return keyValueByteBufferMapAttributeValue_;
    }
    COMMONAPI_EXPORT virtual const ::v2::Test::Audio::Controller::KeyValueByteBuffer &getKeyValueByteBufferMapAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return getKeyValueByteBufferMapAttribute();
    }
    COMMONAPI_EXPORT virtual void setKeyValueByteBufferMapAttribute(::v2::Test::Audio::Controller::KeyValueByteBuffer _value) {
        const bool valueChanged = trySetKeyValueByteBufferMapAttribute(std::move(_value));
        if (valueChanged) {
            fireKeyValueByteBufferMapAttributeChanged(keyValueByteBufferMapAttributeValue_);
        }
    }
    COMMONAPI_EXPORT virtual const ::v2::Test::Audio::Controller::DeviceStateMap &getDeviceStateMapAttribute() {
        return deviceStateMapAttributeValue_;
    }
    COMMONAPI_EXPORT virtual const ::v2::Test::Audio::Controller::DeviceStateMap &getDeviceStateMapAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return getDeviceStateMapAttribute();
    }
    COMMONAPI_EXPORT virtual void setDeviceStateMapAttribute(::v2::Test::Audio::Controller::DeviceStateMap _value) {
        const bool valueChanged = trySetDeviceStateMapAttribute(std::move(_value));
        if (valueChanged) {
            fireDeviceStateMapAttributeChanged(deviceStateMapAttributeValue_);
        }
    }
    COMMONAPI_EXPORT virtual const ::v2::Test::Audio::Controller::StringToShortMap &getStringToShortMapAttribute() {
        return stringToShortMapAttributeValue_;
    }
    COMMONAPI_EXPORT virtual const ::v2::Test::Audio::Controller::StringToShortMap &getStringToShortMapAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return getStringToShortMapAttribute();
    }
    COMMONAPI_EXPORT virtual void setStringToShortMapAttribute(::v2::Test::Audio::Controller::StringToShortMap _value) {
        const bool valueChanged = trySetStringToShortMapAttribute(std::move(_value));
        if (valueChanged) {
            fireStringToShortMapAttributeChanged(stringToShortMapAttributeValue_);
        }
    }
    /*
     * description: 
     * The ccRC system requests to obtain audio focus.
     */
    COMMONAPI_EXPORT virtual void ObtainFocus(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _audioSourceType, Controller::AudioDeviceType _device, ObtainFocusReply_t _reply) {
        (void)_client;
        (void)_audioSourceType;
        (void)_device;
        Controller::FocusControlError error;
        Controller::AudioFocusResultType res = Controller::AudioFocusResultType::ALREADY_EXIST;
        if (!res.validate()) {
            return;
        }
        _reply(error, res);
    }
    /*
     * description: 
     * The ccRC system requests to release audio focus.  Requests that cannot be released return errors.
     */
    COMMONAPI_EXPORT virtual void ReleaseFocus(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _audioSourceType, Controller::AudioDeviceType _device, ReleaseFocusReply_t _reply) {
        (void)_client;
        (void)_audioSourceType;
        (void)_device;
        Controller::FocusControlError error;
        _reply(error);
    }
    /*
     * description: 
     * Set the volume for outside the system.
     */
    COMMONAPI_EXPORT virtual void SetVolume(const std::shared_ptr<CommonAPI::ClientId> _client, uint8_t _volume, SetVolumeReply_t _reply) {
        (void)_client;
        (void)_volume;
        Controller::VolumeControlError error;
        _reply(error);
    }
    /*
     * description: 
     * request to set source volume.
     * There are two member field in the Input parameter.
     * - AudioSourceType: please see "AudioSourceTypes []" for finding detail description
     * - volume : it holds volume level and its level is depending on platform's audio  spec. (varies based on platform, model, misc.)
     * : when this method is invoked, audio manager need to update VolumeInfo.LastVolume
     * 
     * - maxVolume : it defines volume limitation which is described from the requirement
     * - VolumeControlError : please see "setVolume" for more detail explanation
     */
    COMMONAPI_EXPORT virtual void SetSourceVolume(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _audioSourceType, uint16_t _volume, uint32_t _maxVolume, SetSourceVolumeReply_t _reply) {
        (void)_client;
        (void)_audioSourceType;
        (void)_volume;
        (void)_maxVolume;
        Controller::VolumeControlError error;
        _reply(error);
    }
    /*
     * description: 
     * Get FocusStatus and VolumeInfo for audio source type
     */
    COMMONAPI_EXPORT virtual void GetAudioSourceStatus(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _audioSourceType, GetAudioSourceStatusReply_t _reply) {
        (void)_client;
        (void)_audioSourceType;
        Controller::ErrorType error;
        Controller::AudioSourceStatusInfo audioSourceStatusInfo = {};
        _reply(error, audioSourceStatusInfo);
    }
    /*
     * description: 
     * broadcast when audio source type changed
     */
    COMMONAPI_EXPORT virtual void fireFocusStatusChangedEvent(const std::vector< ::v2::Test::Audio::Controller::FocusStatus > &_focusStatus) {
        ControllerStub::fireFocusStatusChangedEvent(_focusStatus);
    }


protected:
    /*
     * description: 
     * test-purposed attribute which is read-write and map data type
     */
    COMMONAPI_EXPORT virtual bool trySetIVIDeviceInfoAttribute(::v2::Test::Audio::Controller::KeyValueString _value) {
        if (!validateIVIDeviceInfoAttributeRequestedValue(_value))
            return false;

        bool valueChanged;
        std::shared_ptr<ControllerStubAdapter> stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if(stubAdapter) {
            stubAdapter->lockIVIDeviceInfoAttribute(true);
            valueChanged = (iVIDeviceInfoAttributeValue_ != _value);
            iVIDeviceInfoAttributeValue_ = std::move(_value);
            stubAdapter->lockIVIDeviceInfoAttribute(false);
        } else {
            valueChanged = (iVIDeviceInfoAttributeValue_ != _value);
            iVIDeviceInfoAttributeValue_ = std::move(_value);
        }

       return valueChanged;
    }
    COMMONAPI_EXPORT virtual bool validateIVIDeviceInfoAttributeRequestedValue(const ::v2::Test::Audio::Controller::KeyValueString &_value) {
        (void)_value;
        return true;
    }
    COMMONAPI_EXPORT virtual void onRemoteIVIDeviceInfoAttributeChanged() {
        // No operation in default
    }
    /*
     * description: 
     * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
     * The list has the following format and is a string with upcase letters.
     * -"YOUTUBE_STREAMING"
     * -"TVING_STREAMING"
     * -"WATCHAR_STREAMING"
     */
    COMMONAPI_EXPORT virtual bool trySetAudioSourceTypesAttribute(std::vector< std::string > _value) {
        if (!validateAudioSourceTypesAttributeRequestedValue(_value))
            return false;

        bool valueChanged;
        std::shared_ptr<ControllerStubAdapter> stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if(stubAdapter) {
            stubAdapter->lockAudioSourceTypesAttribute(true);
            valueChanged = (audioSourceTypesAttributeValue_ != _value);
            audioSourceTypesAttributeValue_ = std::move(_value);
            stubAdapter->lockAudioSourceTypesAttribute(false);
        } else {
            valueChanged = (audioSourceTypesAttributeValue_ != _value);
            audioSourceTypesAttributeValue_ = std::move(_value);
        }

       return valueChanged;
    }
    COMMONAPI_EXPORT virtual bool validateAudioSourceTypesAttributeRequestedValue(const std::vector< std::string > &_value) {
        (void)_value;
        return true;
    }
    /*
     * description: 
     * Contains the Volume Information include min and max levels.
     * The range of these variables depends on each platform specification.
     * -Volume range is defined by audio specification.
     * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
     * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
     * -Mute notify the current mute status. (true : Mute / false : Unmute)
     */
    COMMONAPI_EXPORT virtual bool trySetVolumeInfoAttribute(::v2::Test::Audio::Controller::VolumeInfo _value) {
        if (!validateVolumeInfoAttributeRequestedValue(_value))
            return false;

        bool valueChanged;
        std::shared_ptr<ControllerStubAdapter> stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if(stubAdapter) {
            stubAdapter->lockVolumeInfoAttribute(true);
            valueChanged = (volumeInfoAttributeValue_ != _value);
            volumeInfoAttributeValue_ = std::move(_value);
            stubAdapter->lockVolumeInfoAttribute(false);
        } else {
            valueChanged = (volumeInfoAttributeValue_ != _value);
            volumeInfoAttributeValue_ = std::move(_value);
        }

       return valueChanged;
    }
    COMMONAPI_EXPORT virtual bool validateVolumeInfoAttributeRequestedValue(const ::v2::Test::Audio::Controller::VolumeInfo &_value) {
        (void)_value;
        return true;
    }
    COMMONAPI_EXPORT virtual bool trySetKeyValueByteBufferMapAttribute(::v2::Test::Audio::Controller::KeyValueByteBuffer _value) {
        if (!validateKeyValueByteBufferMapAttributeRequestedValue(_value))
            return false;

        bool valueChanged;
        std::shared_ptr<ControllerStubAdapter> stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if(stubAdapter) {
            stubAdapter->lockKeyValueByteBufferMapAttribute(true);
            valueChanged = (keyValueByteBufferMapAttributeValue_ != _value);
            keyValueByteBufferMapAttributeValue_ = std::move(_value);
            stubAdapter->lockKeyValueByteBufferMapAttribute(false);
        } else {
            valueChanged = (keyValueByteBufferMapAttributeValue_ != _value);
            keyValueByteBufferMapAttributeValue_ = std::move(_value);
        }

       return valueChanged;
    }
    COMMONAPI_EXPORT virtual bool validateKeyValueByteBufferMapAttributeRequestedValue(const ::v2::Test::Audio::Controller::KeyValueByteBuffer &_value) {
        (void)_value;
        return true;
    }
    COMMONAPI_EXPORT virtual bool trySetDeviceStateMapAttribute(::v2::Test::Audio::Controller::DeviceStateMap _value) {
        if (!validateDeviceStateMapAttributeRequestedValue(_value))
            return false;

        bool valueChanged;
        std::shared_ptr<ControllerStubAdapter> stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if(stubAdapter) {
            stubAdapter->lockDeviceStateMapAttribute(true);
            valueChanged = (deviceStateMapAttributeValue_ != _value);
            deviceStateMapAttributeValue_ = std::move(_value);
            stubAdapter->lockDeviceStateMapAttribute(false);
        } else {
            valueChanged = (deviceStateMapAttributeValue_ != _value);
            deviceStateMapAttributeValue_ = std::move(_value);
        }

       return valueChanged;
    }
    COMMONAPI_EXPORT virtual bool validateDeviceStateMapAttributeRequestedValue(const ::v2::Test::Audio::Controller::DeviceStateMap &_value) {
        (void)_value;
        return true;
    }
    COMMONAPI_EXPORT virtual bool trySetStringToShortMapAttribute(::v2::Test::Audio::Controller::StringToShortMap _value) {
        if (!validateStringToShortMapAttributeRequestedValue(_value))
            return false;

        bool valueChanged;
        std::shared_ptr<ControllerStubAdapter> stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if(stubAdapter) {
            stubAdapter->lockStringToShortMapAttribute(true);
            valueChanged = (stringToShortMapAttributeValue_ != _value);
            stringToShortMapAttributeValue_ = std::move(_value);
            stubAdapter->lockStringToShortMapAttribute(false);
        } else {
            valueChanged = (stringToShortMapAttributeValue_ != _value);
            stringToShortMapAttributeValue_ = std::move(_value);
        }

       return valueChanged;
    }
    COMMONAPI_EXPORT virtual bool validateStringToShortMapAttributeRequestedValue(const ::v2::Test::Audio::Controller::StringToShortMap &_value) {
        (void)_value;
        return true;
    }
    class COMMONAPI_EXPORT_CLASS_EXPLICIT RemoteEventHandler: public virtual ControllerStubRemoteEvent {
    public:
        COMMONAPI_EXPORT RemoteEventHandler(ControllerStubDefault *_defaultStub)
            : 
              defaultStub_(_defaultStub) {
        }

        /*
         * description: 
         * test-purposed attribute which is read-write and map data type
         */
        COMMONAPI_EXPORT virtual void onRemoteIVIDeviceInfoAttributeChanged() {
            assert(defaultStub_ !=NULL);
            defaultStub_->onRemoteIVIDeviceInfoAttributeChanged();
        }

        COMMONAPI_EXPORT virtual bool onRemoteSetIVIDeviceInfoAttribute(::v2::Test::Audio::Controller::KeyValueString _value) {
            assert(defaultStub_ !=NULL);
            return defaultStub_->trySetIVIDeviceInfoAttribute(std::move(_value));
        }

        COMMONAPI_EXPORT virtual bool onRemoteSetIVIDeviceInfoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, ::v2::Test::Audio::Controller::KeyValueString _value) {
            (void)_client;
            return onRemoteSetIVIDeviceInfoAttribute(_value);
        }
        /*
         * description: 
         * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
         * The list has the following format and is a string with upcase letters.
         * -"YOUTUBE_STREAMING"
         * -"TVING_STREAMING"
         * -"WATCHAR_STREAMING"
         */
        /*
         * description: 
         * Contains the Volume Information include min and max levels.
         * The range of these variables depends on each platform specification.
         * -Volume range is defined by audio specification.
         * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
         * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
         * -Mute notify the current mute status. (true : Mute / false : Unmute)
         */

    private:
        ControllerStubDefault *defaultStub_;
    };
protected:
    ControllerStubDefault::RemoteEventHandler remoteEventHandler_;

private:

    /*
     * description: 
     * test-purposed attribute which is read-write and map data type
     */
    ::v2::Test::Audio::Controller::KeyValueString iVIDeviceInfoAttributeValue_ {};
    /*
     * description: 
     * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
     * The list has the following format and is a string with upcase letters.
     * -"YOUTUBE_STREAMING"
     * -"TVING_STREAMING"
     * -"WATCHAR_STREAMING"
     */
    std::vector< std::string > audioSourceTypesAttributeValue_ {};
    /*
     * description: 
     * Contains the Volume Information include min and max levels.
     * The range of these variables depends on each platform specification.
     * -Volume range is defined by audio specification.
     * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
     * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
     * -Mute notify the current mute status. (true : Mute / false : Unmute)
     */
    ::v2::Test::Audio::Controller::VolumeInfo volumeInfoAttributeValue_ {};
    ::v2::Test::Audio::Controller::KeyValueByteBuffer keyValueByteBufferMapAttributeValue_ {};
    ::v2::Test::Audio::Controller::DeviceStateMap deviceStateMapAttributeValue_ {};
    ::v2::Test::Audio::Controller::StringToShortMap stringToShortMapAttributeValue_ {};

    CommonAPI::Version interfaceVersion_;
};

} // namespace Audio
} // namespace Test
} // namespace v2


// Compatibility
namespace v2_0 = v2;

#endif // V2_TEST_AUDIO_Controller_STUB_DEFAULT
